//Custom pH Meter Sketch
//Smoothes both temperature and pH
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
/* Visit http://playground.arduino.cc/Main/I2cScanner for code
  you can run to figure out your LCD's I2C address if 0x27 doesn't work. */
LiquidCrystal_I2C lcd(0x27, 16, 2); //16x2 display
//There are a couple of libraries out there. The one I used was
//simply Liquid Crystal_I2C for a generic type display.
const int numReadings = 10;
const int numReadings2 = 20;
const int meterOut1 = 5;
const int meterOut2 = 6;
float readings[numReadings]; //The readings from the analog input
float readings2[numReadings2];
int index = 0; //The index of the current reading
int index2 = 0;
float total = 0; //The running total
float total2 = 0;
float average = 0; //The average
float average2 = 0;
int pHpin = A0;
int tempPin = A1;
int meterdrive1;
int meterdrive2;
int pHvalue = 0;
float val;
float val2;
float tempC;
float temp2;
void setup() {
  lcd.init(); //You may have to use a different command, depending on the
  //library you use
  lcd.backlight();
  pinMode(meterOut1, OUTPUT);
  pinMode(meterOut2, OUTPUT);
  //Initialize serial communication with computer:
  Serial.begin(9600);
  //Initialize all the pH and temperature readings to 0:
  for (int thisReading = 0; thisReading < numReadings; thisReading++) {
    readings[thisReading] = 0;
  }
  for (int thisReading2 = 0; thisReading2 < numReadings2; thisReading2++) {
    readings2[thisReading2] = 0;
  }
  //Configure the reference voltage used for analog input to 1.1V
  analogReference(INTERNAL);
}
void loop() {
  tempC = analogRead(tempPin);
  temp2 = tempC / 9.31; //My calibration factor was 9.31, as determined
  //by the boiling water and ice tests
  pHvalue = analogRead(pHpin);
  val = map(pHvalue, 0, 1023, 0, 1400);
  val = constrain(val, 0, 1400);
  val2 = val / 100;
  meterdrive1 = map(average, 0, 14, 0, 255);
  meterdrive2 = map(average, 14, 0, 0, 255);
  analogWrite(meterOut1, meterdrive1);
  analogWrite(meterOut2, meterdrive2);
  //Subtract the last reading:
  total = total - readings[index];
  //Read from the sensor:
  readings [index] = val2;
  //Add the new reading to the total:
  total = total + readings[index];
  //Advance to the next position in the array:
  index = index + 1;
  //If we're at the end of the array...
  if (index >= numReadings)
    //...wrap around to the beginning:
    index = 0;
  //Calculate the average:
  average = total / numReadings;
  //Subtract the last reading:
  total2 = total2 - readings2[index2];
  //Get readings from the temperature sensor:
  readings2 [index2] = temp2;
  //Add the temperature reading to the total:
  total2 = total2 + readings2[index2];
  //Advance to the next position in the array:
  index2 = index2 + 1;
  //If we're at the end of the array...
  if (index2 >= numReadings2)
    //...wrap around to the beginning:
    index2 = 0;
  //Calculate the average:
  average2 = total2 / numReadings2;
  delay(1); //Delay between reads for stability
  lcd.setCursor(0, 0);
  lcd.print("pH");
  lcd.setCursor(4, 0);
  lcd.print(" ");
  lcd.setCursor(7, 0);
  lcd.print(average, 2); //Truncate to two decimal places
  lcd.setCursor(0, 1);
  lcd.print("Temp ");
  lcd.print(average2 * .98, 1); //Error calculated from empirical measurement
  lcd.print((char)223); //Print the degree symbol
  /* This may vary depending on display. One display used ((char)178) for the
    degree symbol.*/
  lcd.print(" C");
  delay(600);
}
